﻿<AML>
 <Item type="Method" id="B21BD9A2336449D28D0D50CFA0F79B6B" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			erp_ci_qty_update
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                If there is sale order according by choosing "Sale Order",
                -calculate using qty.
                -Update Used QTY in Sale Order.

            Hooks:
                Type:		ItemType : sop_commercial_invoice
                Event:		Server Events ( onAfterAdd )
           
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "erp_ci_qty_update";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                decimal _details_qty = 0;
                decimal _update_used = 0;

                var _sno = this.getProperty("sop_sale_order");
                var _so_order = myInnovator.newItem("sop_sale_order", "get");
                _so_order.setAttribute("select", "id,sop_order_no");
                _so_order.setProperty("id", _sno);
                _so_order.setPropertyCondition("id", "eq");
                _so_order = _so_order.apply();
                var _so_order_count = _so_order.getItemCount();

                if (_so_order_count > 0)
                {

                    var _so_deails = myInnovator.newItem("sop_commercial_invoice_details", "get");
                    _so_deails.setAttribute("select", "id,source_id,stk_code,stk_qty,update_id");
                    _so_deails.setProperty("source_id", _id);
                    _so_deails.setPropertyCondition("source_id", "eq");
                    _so_deails = _so_deails.apply();
                    var _so_details_count = _so_deails.getItemCount();
                    if (_so_details_count > 0)
                    {
                        for (var b = 0; b < _so_details_count; b++)
                        {
                            var so_details_id = _so_deails.getItemByIndex(b);
                            var _update_id = so_details_id.getProperty("update_id");
                            var _stk_qty = so_details_id.getProperty("stk_qty");
                        
                            var _so_details = myInnovator.newItem("sop_sale_order_details", "get");
                            _so_details.setAttribute("select", "id,stk_code,stk_qty,stk_used_qty,stk_ori_qty,stk_price");
                            _so_details.setProperty("id", _update_id);
                            _so_details.setPropertyCondition("id", "eq");
                            _so_details = _so_details.apply();
                            var _quo_details_count = _so_details.getItemCount();
                            if (_quo_details_count > 0)
                            {
                                var _stk_used_qty = _so_details.getProperty("stk_used_qty");
                                _details_qty = Convert.ToDecimal(_stk_qty);
                                decimal _used_qty = Convert.ToDecimal(_stk_used_qty);
                                
                                if (_used_qty == 0)
                                {
                                    _update_used = _details_qty;
                                }
                                else
                                {
                                    _update_used = _used_qty + _details_qty;

                                }
                                Item _update_details = myInnovator.applySQL("Update innovator.[sop_sale_order_details] set stk_used_qty=" + _update_used + " where id='" + _update_id + "'");
                            }
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }		]]></method_code>
  <method_type>C#</method_type>
  <name>erp_ci_qty_update</name>
 </Item>
</AML>